package fxKohtaushallinta;

/**
 * @author Jussi Lipitsäinen
 * @version 28.2.2025
 *
 */
public class Tietue {
    private static final int MAXAVAIN = 10; //Kuinka monta avainsanaa saa olla
    private int id;
    private String otsikko;
    private String kuvaus;
    private Avainsanat avainsanat;
    
    
    public Tietue() {
        //        
    }
    
    
    /**
     * Lukee merkkijonon ("id | otsikko | avainsanat | kuvaus") tiedot kenttiin
     * @param tiedot tiedot sisältävä merkkijono
     * @example
     * <pre name="test">
     *  Tietue t = new Tietue("1 | Tietue 1 | avain1 avain 2 avain 3 | tämä on kuvausteksti");
     *  t.getOtsikko() === "Tietue 1";     *  
     * </pre>
     */
    public Tietue(String tiedot) {
        String[] palaset = tiedot.split("[|]");
        this.otsikko = palaset[1].strip();
        this.avainsanat = new Avainsanat(MAXAVAIN, palaset[2].strip());
        this.kuvaus = palaset[3].strip();
    }
    
    
    /**
     * Lukee merkkijonon ("id | nimi | avainsanat | kuvaus") tiedot kenttiin
     * @param tiedot tiedot sisältävä merkkijono
     */
    public void lueJono(String tiedot) {
        //
    }
    
    
    public void setID(int id) {
        this.id = id;
    }
    
    
    public void setOtsikko(String otsikko) {
        this.otsikko = otsikko;       
    }
    
    
    public void setKuvaus(String kuvaus) {
        this.kuvaus = kuvaus;
    }
    
    
    
    
    public int getID() {
        return this.id;
    }
    
    
    public String getOtsikko() {
        return this.otsikko;
    }
    
    
    public String getKuvaus() {
        return this.kuvaus;
    }
    
    public Avainsanat getAvainsanat() {
        return this.avainsanat;
    }
}